#
# Copyright (C)2022 @BABOLO http://www.babolo.ru/
# pkg = cipalite
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: prep.pleaf.m4,v 1.4 2022/12/18 20:35:15 babolo Exp $
#
#   

eval
#select  _00_
SELECT CINM(x).CIAT(sess)  AS sess
     , CINM(pnode).CIAT(p) AS page
 FROM CINM(x), CINM(pnode)
 WHERE CINM(pnode).CIAT(m) == 'PKG' AND CINM(pnode).CIAT(v) == 'psto'
;
#select  10_2
WITH r AS(SELECT random() AS r, random() AS g)
INSERT INTO SQNM(pkey)(SQAT(pkey), SQAT(sess), SQAT(created), SQAT(ttl), SQAT(gkey))
 SELECT CASE WHEN r.r < 0 THEN -r.r ELSE r.r END
      , SQNM(sess).SQAT(sess)
      , gettimeofday()
      , COALESCE(SQNM(sess).SQAT(ttl), SQNM(pass).SQAT(ttl), SQNM(cipaconf).SQAT(ttl))
      , CASE WHEN r.g < 0 THEN -r.g ELSE r.g END % 10
  FROM r, SQNM(cipaconf), SQNM(x) JOIN SQNM(sess) USING(SQAT(sess)) JOIN SQNM(pass) USING(SQAT(cred))
RETURNING SQNM(pkey).SQAT(pkey) AS key
        , SQNM(pkey).SQAT(ttl)  AS ttl
        , SQNM(pkey).SQAT(gkey) AS gkey
        , ?                     AS sess
        , ?                     AS page
        , (SELECT SQNM(gifs).SQAT(bgif)
            FROM SQNM(gifs)
            WHERE SQAT(symb) = SQNM(pkey).SQAT(gkey)
          )                     AS symb
;
#style   00y001
prep
#display 001001
#close   101001
#close   _0_
