#
# Copyright (C)2022 @BABOLO http://www.babolo.ru/
# pkg = cipalite
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: spas.pleaf.m4,v 1.8 2022/09/04 15:04:21 babolo Exp $
#

eval
#select  1002
SELECT SQNM(x).SQAT(cipa)
    || CASE WHEN SQNM(sess).SQAT(flags) & SessAuthName
            THEN ':' || CAST(  ( (SQAT(sess) * SQNM(cipaconf).SQAT(a3))
                               + SQNM(cipaconf).SQAT(a2)
                               ) % SQNM(cipaconf).SQAT(a1)
                            AS TEXT
                            )
            ELSE ''
       END             AS realm
     , SQNM(x).SQAT(h) AS host
 FROM SQNM(x) JOIN SQNM(sess) USING(SQAT(sess))
    , SQNM(cipaconf)
 WHERE SQNM(sess).SQAT(flags) & SessClaimPass
;
#perform 0002
UPDATE SQNM(sess) SET SQAT(flags) = SQNM(sess).SQAT(flags) & ~SessClaimPass
 FROM SQNM(x)
 WHERE SQNM(sess).SQAT(sess) == SQNM(x).SQAT(sess)
   AND SQNM(sess).SQAT(flags) & SessClaimPass
   AND SQNM(sess).SQAT(srcip) == SQNM(x).SQAT(srcip)
   AND (  CINM(x).CIAT(cred) > 0
       OR NOT CINM(x).CIAT(u)
       OR (   CINM(x).CIAT(login) == SQNM(sess).CIAT(login)
          AND (  CINM(x).CIAT(pass) == SQNM(sess).CIAT(pass)
              OR (CINM(x).CIAT(pass) IS NULL AND SQNM(sess).CIAT(pass) IS NULL)
       )  )   )
;
#select  _01_
SELECT ? FROM CINM(x) WHERE CINM(x).CIAT(u) == 1;
#eval    00_
##style   00y001
exit
##echo    000001
status401
##display 001001
##exit
#close   101
#close   _0_
